/* tslint:disable */
/* eslint-disable */
/**
 * Coscine Web API
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from '../../configuration';
import type { AxiosPromise, AxiosInstance, RawAxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, type RequestArgs, BaseAPI, RequiredError, operationServerMap } from '../../base';
// @ts-ignore
import type { MessageDtoPagedResponse } from '../../@coscine/model';
// @ts-ignore
import type { MessageType } from '../../@coscine/model';
/**
 * SystemStatusApi - axios parameter creator
 * @export
 */
export const SystemStatusApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2SystemStatusOptions: async (options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/system/status`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'OPTIONS', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves the internal messages.
         * @param {string} [startDateAfter] Will only return messages that have their start date after this date (UTC).
         * @param {string} [startDateBefore] Will only return messages that have their start date before this date (UTC).
         * @param {string} [endDateAfter] Will only return messages that have their end date after this date (UTC).
         * @param {string} [endDateBefore] Will only return messages that have their end date before this date (UTC).
         * @param {MessageType} [type] Filter messages by their type  (e.g. information, warning, error).
         * @param {string} [searchTerm] Filter messages by text contained in the messages or title.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getInternalMessages: async (startDateAfter?: string, startDateBefore?: string, endDateAfter?: string, endDateBefore?: string, type?: MessageType, searchTerm?: string, pageNumber?: number, pageSize?: number, orderBy?: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/system/status/internal`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (startDateAfter !== undefined) {
                localVarQueryParameter['StartDateAfter'] = (startDateAfter as any instanceof Date) ?
                    (startDateAfter as any).toISOString() :
                    startDateAfter;
            }

            if (startDateBefore !== undefined) {
                localVarQueryParameter['StartDateBefore'] = (startDateBefore as any instanceof Date) ?
                    (startDateBefore as any).toISOString() :
                    startDateBefore;
            }

            if (endDateAfter !== undefined) {
                localVarQueryParameter['EndDateAfter'] = (endDateAfter as any instanceof Date) ?
                    (endDateAfter as any).toISOString() :
                    endDateAfter;
            }

            if (endDateBefore !== undefined) {
                localVarQueryParameter['EndDateBefore'] = (endDateBefore as any instanceof Date) ?
                    (endDateBefore as any).toISOString() :
                    endDateBefore;
            }

            if (type !== undefined) {
                localVarQueryParameter['Type'] = type;
            }

            if (searchTerm !== undefined) {
                localVarQueryParameter['SearchTerm'] = searchTerm;
            }

            if (pageNumber !== undefined) {
                localVarQueryParameter['PageNumber'] = pageNumber;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['PageSize'] = pageSize;
            }

            if (orderBy !== undefined) {
                localVarQueryParameter['OrderBy'] = orderBy;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrieves the NOC messages.
         * @param {string} [startDateAfter] Will only return messages that have their start date after this date (UTC).
         * @param {string} [startDateBefore] Will only return messages that have their start date before this date (UTC).
         * @param {string} [endDateAfter] Will only return messages that have their end date after this date (UTC).
         * @param {string} [endDateBefore] Will only return messages that have their end date before this date (UTC).
         * @param {MessageType} [type] Filter messages by their type  (e.g. information, warning, error).
         * @param {string} [searchTerm] Filter messages by text contained in the messages or title.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getNocMessages: async (startDateAfter?: string, startDateBefore?: string, endDateAfter?: string, endDateBefore?: string, type?: MessageType, searchTerm?: string, pageNumber?: number, pageSize?: number, orderBy?: string, options: RawAxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v2/system/status/noc`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Bearer required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (startDateAfter !== undefined) {
                localVarQueryParameter['StartDateAfter'] = (startDateAfter as any instanceof Date) ?
                    (startDateAfter as any).toISOString() :
                    startDateAfter;
            }

            if (startDateBefore !== undefined) {
                localVarQueryParameter['StartDateBefore'] = (startDateBefore as any instanceof Date) ?
                    (startDateBefore as any).toISOString() :
                    startDateBefore;
            }

            if (endDateAfter !== undefined) {
                localVarQueryParameter['EndDateAfter'] = (endDateAfter as any instanceof Date) ?
                    (endDateAfter as any).toISOString() :
                    endDateAfter;
            }

            if (endDateBefore !== undefined) {
                localVarQueryParameter['EndDateBefore'] = (endDateBefore as any instanceof Date) ?
                    (endDateBefore as any).toISOString() :
                    endDateBefore;
            }

            if (type !== undefined) {
                localVarQueryParameter['Type'] = type;
            }

            if (searchTerm !== undefined) {
                localVarQueryParameter['SearchTerm'] = searchTerm;
            }

            if (pageNumber !== undefined) {
                localVarQueryParameter['PageNumber'] = pageNumber;
            }

            if (pageSize !== undefined) {
                localVarQueryParameter['PageSize'] = pageSize;
            }

            if (orderBy !== undefined) {
                localVarQueryParameter['OrderBy'] = orderBy;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * SystemStatusApi - functional programming interface
 * @export
 */
export const SystemStatusApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = SystemStatusApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV2SystemStatusOptions(options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV2SystemStatusOptions(options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['SystemStatusApi.apiV2SystemStatusOptions']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves the internal messages.
         * @param {string} [startDateAfter] Will only return messages that have their start date after this date (UTC).
         * @param {string} [startDateBefore] Will only return messages that have their start date before this date (UTC).
         * @param {string} [endDateAfter] Will only return messages that have their end date after this date (UTC).
         * @param {string} [endDateBefore] Will only return messages that have their end date before this date (UTC).
         * @param {MessageType} [type] Filter messages by their type  (e.g. information, warning, error).
         * @param {string} [searchTerm] Filter messages by text contained in the messages or title.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getInternalMessages(startDateAfter?: string, startDateBefore?: string, endDateAfter?: string, endDateBefore?: string, type?: MessageType, searchTerm?: string, pageNumber?: number, pageSize?: number, orderBy?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MessageDtoPagedResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getInternalMessages(startDateAfter, startDateBefore, endDateAfter, endDateBefore, type, searchTerm, pageNumber, pageSize, orderBy, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['SystemStatusApi.getInternalMessages']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
        /**
         * 
         * @summary Retrieves the NOC messages.
         * @param {string} [startDateAfter] Will only return messages that have their start date after this date (UTC).
         * @param {string} [startDateBefore] Will only return messages that have their start date before this date (UTC).
         * @param {string} [endDateAfter] Will only return messages that have their end date after this date (UTC).
         * @param {string} [endDateBefore] Will only return messages that have their end date before this date (UTC).
         * @param {MessageType} [type] Filter messages by their type  (e.g. information, warning, error).
         * @param {string} [searchTerm] Filter messages by text contained in the messages or title.
         * @param {number} [pageNumber] The desired page number. Should be greater than or equal to 1. Default is 1.
         * @param {number} [pageSize] The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
         * @param {string} [orderBy] Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getNocMessages(startDateAfter?: string, startDateBefore?: string, endDateAfter?: string, endDateBefore?: string, type?: MessageType, searchTerm?: string, pageNumber?: number, pageSize?: number, orderBy?: string, options?: RawAxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MessageDtoPagedResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getNocMessages(startDateAfter, startDateBefore, endDateAfter, endDateBefore, type, searchTerm, pageNumber, pageSize, orderBy, options);
            const localVarOperationServerIndex = configuration?.serverIndex ?? 0;
            const localVarOperationServerBasePath = operationServerMap['SystemStatusApi.getNocMessages']?.[localVarOperationServerIndex]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, localVarOperationServerBasePath || basePath);
        },
    }
};

/**
 * SystemStatusApi - factory interface
 * @export
 */
export const SystemStatusApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = SystemStatusApiFp(configuration)
    return {
        /**
         * 
         * @summary Responds with the HTTP methods allowed for the endpoint.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV2SystemStatusOptions(options?: RawAxiosRequestConfig): AxiosPromise<void> {
            return localVarFp.apiV2SystemStatusOptions(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves the internal messages.
         * @param {SystemStatusApiGetInternalMessagesRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getInternalMessages(requestParameters: SystemStatusApiGetInternalMessagesRequest = {}, options?: RawAxiosRequestConfig): AxiosPromise<MessageDtoPagedResponse> {
            return localVarFp.getInternalMessages(requestParameters.startDateAfter, requestParameters.startDateBefore, requestParameters.endDateAfter, requestParameters.endDateBefore, requestParameters.type, requestParameters.searchTerm, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrieves the NOC messages.
         * @param {SystemStatusApiGetNocMessagesRequest} requestParameters Request parameters.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getNocMessages(requestParameters: SystemStatusApiGetNocMessagesRequest = {}, options?: RawAxiosRequestConfig): AxiosPromise<MessageDtoPagedResponse> {
            return localVarFp.getNocMessages(requestParameters.startDateAfter, requestParameters.startDateBefore, requestParameters.endDateAfter, requestParameters.endDateBefore, requestParameters.type, requestParameters.searchTerm, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for getInternalMessages operation in SystemStatusApi.
 * @export
 * @interface SystemStatusApiGetInternalMessagesRequest
 */
export interface SystemStatusApiGetInternalMessagesRequest {
    /**
     * Will only return messages that have their start date after this date (UTC).
     * @type {string}
     * @memberof SystemStatusApiGetInternalMessages
     */
    readonly startDateAfter?: string

    /**
     * Will only return messages that have their start date before this date (UTC).
     * @type {string}
     * @memberof SystemStatusApiGetInternalMessages
     */
    readonly startDateBefore?: string

    /**
     * Will only return messages that have their end date after this date (UTC).
     * @type {string}
     * @memberof SystemStatusApiGetInternalMessages
     */
    readonly endDateAfter?: string

    /**
     * Will only return messages that have their end date before this date (UTC).
     * @type {string}
     * @memberof SystemStatusApiGetInternalMessages
     */
    readonly endDateBefore?: string

    /**
     * Filter messages by their type  (e.g. information, warning, error).
     * @type {MessageType}
     * @memberof SystemStatusApiGetInternalMessages
     */
    readonly type?: MessageType

    /**
     * Filter messages by text contained in the messages or title.
     * @type {string}
     * @memberof SystemStatusApiGetInternalMessages
     */
    readonly searchTerm?: string

    /**
     * The desired page number. Should be greater than or equal to 1. Default is 1.
     * @type {number}
     * @memberof SystemStatusApiGetInternalMessages
     */
    readonly pageNumber?: number

    /**
     * The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
     * @type {number}
     * @memberof SystemStatusApiGetInternalMessages
     */
    readonly pageSize?: number

    /**
     * Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
     * @type {string}
     * @memberof SystemStatusApiGetInternalMessages
     */
    readonly orderBy?: string
}

/**
 * Request parameters for getNocMessages operation in SystemStatusApi.
 * @export
 * @interface SystemStatusApiGetNocMessagesRequest
 */
export interface SystemStatusApiGetNocMessagesRequest {
    /**
     * Will only return messages that have their start date after this date (UTC).
     * @type {string}
     * @memberof SystemStatusApiGetNocMessages
     */
    readonly startDateAfter?: string

    /**
     * Will only return messages that have their start date before this date (UTC).
     * @type {string}
     * @memberof SystemStatusApiGetNocMessages
     */
    readonly startDateBefore?: string

    /**
     * Will only return messages that have their end date after this date (UTC).
     * @type {string}
     * @memberof SystemStatusApiGetNocMessages
     */
    readonly endDateAfter?: string

    /**
     * Will only return messages that have their end date before this date (UTC).
     * @type {string}
     * @memberof SystemStatusApiGetNocMessages
     */
    readonly endDateBefore?: string

    /**
     * Filter messages by their type  (e.g. information, warning, error).
     * @type {MessageType}
     * @memberof SystemStatusApiGetNocMessages
     */
    readonly type?: MessageType

    /**
     * Filter messages by text contained in the messages or title.
     * @type {string}
     * @memberof SystemStatusApiGetNocMessages
     */
    readonly searchTerm?: string

    /**
     * The desired page number. Should be greater than or equal to 1. Default is 1.
     * @type {number}
     * @memberof SystemStatusApiGetNocMessages
     */
    readonly pageNumber?: number

    /**
     * The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10.
     * @type {number}
     * @memberof SystemStatusApiGetNocMessages
     */
    readonly pageSize?: number

    /**
     * Gets or sets the field name used for ordering the results.  The order is constructed by an order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc.
     * @type {string}
     * @memberof SystemStatusApiGetNocMessages
     */
    readonly orderBy?: string
}

/**
 * SystemStatusApi - object-oriented interface
 * @export
 * @class SystemStatusApi
 * @extends {BaseAPI}
 */
export class SystemStatusApi extends BaseAPI {
    /**
     * 
     * @summary Responds with the HTTP methods allowed for the endpoint.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SystemStatusApi
     */
    public apiV2SystemStatusOptions(options?: RawAxiosRequestConfig) {
        return SystemStatusApiFp(this.configuration).apiV2SystemStatusOptions(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves the internal messages.
     * @param {SystemStatusApiGetInternalMessagesRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SystemStatusApi
     */
    public getInternalMessages(requestParameters: SystemStatusApiGetInternalMessagesRequest = {}, options?: RawAxiosRequestConfig) {
        return SystemStatusApiFp(this.configuration).getInternalMessages(requestParameters.startDateAfter, requestParameters.startDateBefore, requestParameters.endDateAfter, requestParameters.endDateBefore, requestParameters.type, requestParameters.searchTerm, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrieves the NOC messages.
     * @param {SystemStatusApiGetNocMessagesRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SystemStatusApi
     */
    public getNocMessages(requestParameters: SystemStatusApiGetNocMessagesRequest = {}, options?: RawAxiosRequestConfig) {
        return SystemStatusApiFp(this.configuration).getNocMessages(requestParameters.startDateAfter, requestParameters.startDateBefore, requestParameters.endDateAfter, requestParameters.endDateBefore, requestParameters.type, requestParameters.searchTerm, requestParameters.pageNumber, requestParameters.pageSize, requestParameters.orderBy, options).then((request) => request(this.axios, this.basePath));
    }
}

